searchData={"items":[{"type":"module","doc":"An adapter for Commanded to use ExESDB as the event store.\n  for reference, see: https://hexdocs.pm/commanded/Commanded.EventStore.Adapter.html","title":"ExESDB.Commanded.Adapter","ref":"ExESDB.Commanded.Adapter.html"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.adapter_meta/0","ref":"ExESDB.Commanded.Adapter.html#t:adapter_meta/0"},{"type":"function","doc":"Append one or more events to a stream atomically.","title":"ExESDB.Commanded.Adapter.append_to_stream/5","ref":"ExESDB.Commanded.Adapter.html#append_to_stream/5"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.application/0","ref":"ExESDB.Commanded.Adapter.html#t:application/0"},{"type":"function","doc":"Return a child spec defining all processes required by the event store.","title":"ExESDB.Commanded.Adapter.child_spec/2","ref":"ExESDB.Commanded.Adapter.html#child_spec/2"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.config/0","ref":"ExESDB.Commanded.Adapter.html#t:config/0"},{"type":"function","doc":"Delete a snapshot of the current state of the event store.","title":"ExESDB.Commanded.Adapter.delete_snapshot/2","ref":"ExESDB.Commanded.Adapter.html#delete_snapshot/2"},{"type":"function","doc":"Delete a subscription.","title":"ExESDB.Commanded.Adapter.delete_subscription/3","ref":"ExESDB.Commanded.Adapter.html#delete_subscription/3"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.error/0","ref":"ExESDB.Commanded.Adapter.html#t:error/0"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.expected_version/0","ref":"ExESDB.Commanded.Adapter.html#t:expected_version/0"},{"type":"function","doc":"Record a snapshot of the current state of the event store.","title":"ExESDB.Commanded.Adapter.record_snapshot/2","ref":"ExESDB.Commanded.Adapter.html#record_snapshot/2"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.source_uuid/0","ref":"ExESDB.Commanded.Adapter.html#t:source_uuid/0"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.start_from/0","ref":"ExESDB.Commanded.Adapter.html#t:start_from/0"},{"type":"function","doc":"Streams events from the given stream, in the order in which they were\n  originally written.","title":"ExESDB.Commanded.Adapter.stream_forward/4","ref":"ExESDB.Commanded.Adapter.html#stream_forward/4"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.stream_uuid/0","ref":"ExESDB.Commanded.Adapter.html#t:stream_uuid/0"},{"type":"function","doc":"Create a transient subscription to a single event stream.\n\n  The event store will publish any events appended to the given stream to the\n  `subscriber` process as an `{:events, events}` message.\n\n  The subscriber does not need to acknowledge receipt of the events.","title":"ExESDB.Commanded.Adapter.subscribe/2","ref":"ExESDB.Commanded.Adapter.html#subscribe/2"},{"type":"function","doc":"Create a persistent subscription to an event stream.","title":"ExESDB.Commanded.Adapter.subscribe_to/6","ref":"ExESDB.Commanded.Adapter.html#subscribe_to/6"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.subscriber/0","ref":"ExESDB.Commanded.Adapter.html#t:subscriber/0"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.subscription/0","ref":"ExESDB.Commanded.Adapter.html#t:subscription/0"},{"type":"type","doc":"","title":"ExESDB.Commanded.Adapter.subscription_name/0","ref":"ExESDB.Commanded.Adapter.html#t:subscription_name/0"},{"type":"module","doc":"Handles conversion between ExESDB events and Commanded events.","title":"ExESDB.Commanded.Adapter.EventConverter","ref":"ExESDB.Commanded.Adapter.EventConverter.html"},{"type":"function","doc":"Converts a single ExESDB EventRecord to Commanded RecordedEvent.","title":"ExESDB.Commanded.Adapter.EventConverter.convert_event_record/1","ref":"ExESDB.Commanded.Adapter.EventConverter.html#convert_event_record/1"},{"type":"function","doc":"Converts a list of events to Commanded format.","title":"ExESDB.Commanded.Adapter.EventConverter.convert_events/1","ref":"ExESDB.Commanded.Adapter.EventConverter.html#convert_events/1"},{"type":"function","doc":"Parses metadata from various formats (binary, map, or nil).","title":"ExESDB.Commanded.Adapter.EventConverter.parse_metadata/1","ref":"ExESDB.Commanded.Adapter.EventConverter.html#parse_metadata/1"},{"type":"module","doc":"Helper functions for stream operations and subscription type detection.","title":"ExESDB.Commanded.Adapter.StreamHelper","ref":"ExESDB.Commanded.Adapter.StreamHelper.html"},{"type":"function","doc":"Determines if a stream subscription should be allowed based on the stream type.\nAllows:\n- $all streams (global) - aggregates should subscribe to this and filter by stream_id\n- Event type streams ($et-*) - for projection systems\n\nBlocks:\n- Individual stream subscriptions to prevent creating separate emitters per aggregate","title":"ExESDB.Commanded.Adapter.StreamHelper.allowed_stream?/1","ref":"ExESDB.Commanded.Adapter.StreamHelper.html#allowed_stream?/1"},{"type":"function","doc":"Maps ExESDB error responses to Commanded error format.","title":"ExESDB.Commanded.Adapter.StreamHelper.map_error/1","ref":"ExESDB.Commanded.Adapter.StreamHelper.html#map_error/1"},{"type":"function","doc":"Normalizes Commanded expected versions to ExESDB expected versions.","title":"ExESDB.Commanded.Adapter.StreamHelper.normalize_expected_version/1","ref":"ExESDB.Commanded.Adapter.StreamHelper.html#normalize_expected_version/1"},{"type":"function","doc":"Converts start_from parameter to version number for ExESDB.","title":"ExESDB.Commanded.Adapter.StreamHelper.normalize_start_version/1","ref":"ExESDB.Commanded.Adapter.StreamHelper.html#normalize_start_version/1"},{"type":"function","doc":"Extracts store configuration from adapter metadata.","title":"ExESDB.Commanded.Adapter.StreamHelper.store_id/1","ref":"ExESDB.Commanded.Adapter.StreamHelper.html#store_id/1"},{"type":"function","doc":"Extracts stream prefix from adapter metadata.","title":"ExESDB.Commanded.Adapter.StreamHelper.stream_prefix/1","ref":"ExESDB.Commanded.Adapter.StreamHelper.html#stream_prefix/1"},{"type":"function","doc":"Converts a stream identifier to subscription type and selector.","title":"ExESDB.Commanded.Adapter.StreamHelper.stream_to_subscription_params/2","ref":"ExESDB.Commanded.Adapter.StreamHelper.html#stream_to_subscription_params/2"},{"type":"module","doc":"Supervised GenServer that handles subscription proxies for converting ExESDB events to Commanded format.\n\nThis process is supervised and maintains its registration with the ExESDB store,\nensuring event delivery continues even after process restarts.","title":"ExESDB.Commanded.Adapter.SubscriptionProxy","ref":"ExESDB.Commanded.Adapter.SubscriptionProxy.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Commanded.Adapter.SubscriptionProxy.child_spec/1","ref":"ExESDB.Commanded.Adapter.SubscriptionProxy.html#child_spec/1"},{"type":"function","doc":"Starts a supervised subscription proxy process.","title":"ExESDB.Commanded.Adapter.SubscriptionProxy.start_link/1","ref":"ExESDB.Commanded.Adapter.SubscriptionProxy.html#start_link/1"},{"type":"function","doc":"Legacy function for backward compatibility - now starts supervised process.","title":"ExESDB.Commanded.Adapter.SubscriptionProxy.start_proxy/1","ref":"ExESDB.Commanded.Adapter.SubscriptionProxy.html#start_proxy/1"},{"type":"module","doc":"Supervisor for SubscriptionProxy processes.\n\nThis supervisor ensures that SubscriptionProxy processes are restarted\nwhen they crash, and their PIDs are updated in the ExESDB store.","title":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor","ref":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.child_spec/1","ref":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.html#child_spec/1"},{"type":"function","doc":"List all running proxy processes.","title":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.list_proxies/0","ref":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.html#list_proxies/0"},{"type":"function","doc":"","title":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.start_link/1","ref":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.html#start_link/1"},{"type":"function","doc":"Start a supervised SubscriptionProxy.","title":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.start_proxy/1","ref":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.html#start_proxy/1"},{"type":"function","doc":"Stop a supervised SubscriptionProxy.","title":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.stop_proxy/1","ref":"ExESDB.Commanded.Adapter.SubscriptionProxySupervisor.html#stop_proxy/1"},{"type":"module","doc":"A process that subscribes to the EventStore's Phoenix PubSub ` :$all` topic\nand filters events by stream_id for aggregate transient subscriptions.\n\nThis replaces the previous subscription mechanism for aggregates, providing\na more scalable approach that leverages Phoenix PubSub for event distribution.\n\nEach AggregateListener process:\n1. Subscribes to the ` :$all` Phoenix PubSub topic\n2. Filters incoming events based on the target stream_id\n3. Transforms ExESDB.Schema.EventRecord to Commanded.EventStore.RecordedEvent\n4. Forwards matching events to the subscriber process","title":"ExESDB.Commanded.AggregateListener","ref":"ExESDB.Commanded.AggregateListener.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Commanded.AggregateListener.child_spec/1","ref":"ExESDB.Commanded.AggregateListener.html#child_spec/1"},{"type":"type","doc":"","title":"ExESDB.Commanded.AggregateListener.listener_config/0","ref":"ExESDB.Commanded.AggregateListener.html#t:listener_config/0"},{"type":"function","doc":"Starts an AggregateListener without linking to the calling process.\nUseful for transient subscriptions where we don't want to crash the caller.","title":"ExESDB.Commanded.AggregateListener.start/1","ref":"ExESDB.Commanded.AggregateListener.html#start/1"},{"type":"function","doc":"Starts an AggregateListener for the given stream.","title":"ExESDB.Commanded.AggregateListener.start_link/1","ref":"ExESDB.Commanded.AggregateListener.html#start_link/1"},{"type":"function","doc":"- config: Map containing:\n  - store_id: The EventStore identifier\n  - stream_id: The target stream to filter events for\n  - subscriber: The process to send filtered events to\n  - pubsub_name: The Phoenix PubSub name (defaults to :ex_esdb_pubsub)\n  - replay_historical_events?: Whether to replay historical events on startup (defaults to true)","title":"Parameters - ExESDB.Commanded.AggregateListener.start_link/1","ref":"ExESDB.Commanded.AggregateListener.html#start_link/1-parameters"},{"type":"function","doc":"Stops the AggregateListener process.","title":"ExESDB.Commanded.AggregateListener.stop/1","ref":"ExESDB.Commanded.AggregateListener.html#stop/1"},{"type":"module","doc":"DynamicSupervisor for managing AggregateListener processes.\n\nThis supervisor is responsible for:\n1. Starting and stopping AggregateListener processes\n2. Ensuring proper supervision and restart strategies\n3. Maintaining a registry of active listeners\n4. Cleanup on application shutdown","title":"ExESDB.Commanded.AggregateListenerSupervisor","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Commanded.AggregateListenerSupervisor.child_spec/1","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html#child_spec/1"},{"type":"function","doc":"Lists all active listeners with their details.","title":"ExESDB.Commanded.AggregateListenerSupervisor.list_listeners/0","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html#list_listeners/0"},{"type":"function","doc":"","title":"ExESDB.Commanded.AggregateListenerSupervisor.start_link/1","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html#start_link/1"},{"type":"function","doc":"Starts a new AggregateListener under supervision.\n\nReturns the PID of the started listener or an error.","title":"ExESDB.Commanded.AggregateListenerSupervisor.start_listener/1","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html#start_listener/1"},{"type":"function","doc":"Returns statistics about active listeners.","title":"ExESDB.Commanded.AggregateListenerSupervisor.stats/0","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html#stats/0"},{"type":"function","doc":"Stops a specific AggregateListener.","title":"ExESDB.Commanded.AggregateListenerSupervisor.stop_listener/1","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html#stop_listener/1"},{"type":"function","doc":"Stops all listeners for a specific store and stream combination.","title":"ExESDB.Commanded.AggregateListenerSupervisor.stop_listeners_for_stream/2","ref":"ExESDB.Commanded.AggregateListenerSupervisor.html#stop_listeners_for_stream/2"},{"type":"module","doc":"Configuration validation and normalization for ExESDB.Commanded.Adapter.\n\nThis module provides standardized configuration handling with proper validation,\nerror handling, and normalization to ensure consistent behavior between Commanded\nand ExESDB systems.","title":"ExESDB.Commanded.Config","ref":"ExESDB.Commanded.Config.html"},{"type":"type","doc":"","title":"ExESDB.Commanded.Config.adapter_config/0","ref":"ExESDB.Commanded.Config.html#t:adapter_config/0"},{"type":"type","doc":"","title":"ExESDB.Commanded.Config.config/0","ref":"ExESDB.Commanded.Config.html#t:config/0"},{"type":"function","doc":"Gets the connection timeout from configuration or environment.","title":"ExESDB.Commanded.Config.connection_timeout/1","ref":"ExESDB.Commanded.Config.html#connection_timeout/1"},{"type":"function","doc":"Gets the retry attempts from configuration or environment.","title":"ExESDB.Commanded.Config.retry_attempts/1","ref":"ExESDB.Commanded.Config.html#retry_attempts/1"},{"type":"function","doc":"Gets the retry backoff from configuration or environment.","title":"ExESDB.Commanded.Config.retry_backoff/1","ref":"ExESDB.Commanded.Config.html#retry_backoff/1"},{"type":"function","doc":"Gets the serializer module from configuration or environment.","title":"ExESDB.Commanded.Config.serializer/1","ref":"ExESDB.Commanded.Config.html#serializer/1"},{"type":"function","doc":"Gets the store ID from configuration or environment.","title":"ExESDB.Commanded.Config.store_id/1","ref":"ExESDB.Commanded.Config.html#store_id/1"},{"type":"function","doc":"Gets the stream prefix from configuration or environment.\n\nStream prefixes cannot contain dashes to avoid conflicts with ExESDB\ninternal naming conventions.","title":"ExESDB.Commanded.Config.stream_prefix/1","ref":"ExESDB.Commanded.Config.html#stream_prefix/1"},{"type":"function","doc":"Checks if libcluster should be used for node discovery.","title":"ExESDB.Commanded.Config.use_libcluster?/1","ref":"ExESDB.Commanded.Config.html#use_libcluster?/1"},{"type":"function","doc":"Validates and normalizes configuration for ExESDB.Commanded.Adapter.","title":"ExESDB.Commanded.Config.validate/1","ref":"ExESDB.Commanded.Config.html#validate/1"},{"type":"function","doc":"* `:store_id` - ExESDB store identifier (required)\n* `:stream_prefix` - Prefix for all streams (default: \"\")\n* `:serializer` - Serialization module (default: Jason)\n* `:use_libcluster` - Whether to use libcluster for node discovery (default: true)\n* `:connection_timeout` - Connection timeout in ms (default: 10_000)\n* `:retry_attempts` - Number of retry attempts for failed operations (default: 3)\n* `:retry_backoff` - Backoff interval between retries in ms (default: 1_000)","title":"Options - ExESDB.Commanded.Config.validate/1","ref":"ExESDB.Commanded.Config.html#validate/1-options"},{"type":"function","doc":"iex> ExESDB.Commanded.Config.validate([store_id: :my_store])\n    {:ok, %{store_id: :my_store, stream_prefix: \"\", ...}}\n    \n    iex> ExESDB.Commanded.Config.validate([])\n    {:error, {:missing_required_config, [:store_id]}}","title":"Examples - ExESDB.Commanded.Config.validate/1","ref":"ExESDB.Commanded.Config.html#validate/1-examples"},{"type":"function","doc":"Validates libcluster topology configuration.","title":"ExESDB.Commanded.Config.validate_libcluster_config/1","ref":"ExESDB.Commanded.Config.html#validate_libcluster_config/1"},{"type":"function","doc":"Validates that the serializer module is available and has required functions.","title":"ExESDB.Commanded.Config.validate_serializer/1","ref":"ExESDB.Commanded.Config.html#validate_serializer/1"},{"type":"module","doc":"A mapper for Commanded to use ExESDB as the event store.","title":"ExESDB.Commanded.Mapper","ref":"ExESDB.Commanded.Mapper.html"},{"type":"function","doc":"Converts a Commanded EventData struct to an ExESDB.Schema.NewEvent struct.","title":"ExESDB.Commanded.Mapper.to_new_event/1","ref":"ExESDB.Commanded.Mapper.html#to_new_event/1"},{"type":"function","doc":"Converts an ExESDB.Schema.EventRecord struct to a Commanded RecordedEvent struct.","title":"ExESDB.Commanded.Mapper.to_recorded_event/1","ref":"ExESDB.Commanded.Mapper.html#to_recorded_event/1"},{"type":"function","doc":"Converts an ExESDB.Schema.SnapshotRecord struct to a Commanded SnapshotData struct.","title":"ExESDB.Commanded.Mapper.to_snapshot_data/1","ref":"ExESDB.Commanded.Mapper.html#to_snapshot_data/1"},{"type":"function","doc":"Converts a Commanded SnapshotData struct to an ExESDB.Schema.SnapshotRecord struct.","title":"ExESDB.Commanded.Mapper.to_snapshot_record/1","ref":"ExESDB.Commanded.Mapper.html#to_snapshot_record/1"},{"type":"extras","doc":"","title":"ADR","ref":"adr.html"},{"type":"extras","doc":"","title":"CHANGELOG","ref":"changelog.html"},{"type":"extras","doc":"","title":"Getting Started","ref":"getting-started.html"},{"type":"extras","doc":"---","title":"Getting Started Guide - Getting Started","ref":"getting-started.html#getting-started-guide"},{"type":"extras","doc":"Welcome to the ExESDB Commanded Adapter! This guide will walk you through setting up the adapter to work with your Commanded application using ExESDB as your event store.","title":"Introduction - Getting Started","ref":"getting-started.html#introduction"},{"type":"extras","doc":"- **Elixir Version:** Ensure your Elixir environment is 1.17 or newer.\n- **Commanded Library:** This package acts as an adapter for Commanded, so you'll need to have it set up in your Elixir project.","title":"Prerequisites - Getting Started","ref":"getting-started.html#prerequisites"},{"type":"extras","doc":"Add the adapter to your Mix dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_esdb_commanded, \"~> 0.1.0\"},\n  ]\nend\n```\n\nRun `mix deps.get` to fetch the dependency.","title":"Installation - Getting Started","ref":"getting-started.html#installation"},{"type":"extras","doc":"Configuration can be done in your `config/config.exs` file.","title":"Configuration - Getting Started","ref":"getting-started.html#configuration"},{"type":"extras","doc":"Add the following configuration to specify the adapter for your Commanded application:\n\n```elixir\nconfig :my_app, MyApp.CommandedApp,\n  event_store: [\n    adapter: ExESDB.Commanded.Adapter,\n    store_id: :my_store_id,\n    stream_prefix: \"my_app_\",\n    event_type_mapper: MyApp.EventTypeMapper\n  ]\n```","title":"Basic Configuration - Getting Started","ref":"getting-started.html#basic-configuration"},{"type":"extras","doc":"Make sure to check environment variables for dynamic configurations:\n\n- `EXESDB_COMMANDED_STORE_ID`\n- `EXESDB_COMMANDED_STREAM_PREFIX`\n\nSet these accordingly in your environment or `runtime.exs`.","title":"Environment Variables - Getting Started","ref":"getting-started.html#environment-variables"},{"type":"extras","doc":"You can also tweak other settings like connection timeout, retry attempts, and backoff intervals:\n\n```elixir\nconfig :ex_esdb_commanded_adapter,\n  connection_timeout: 15_000,\n  retry_attempts: 5,\n  retry_backoff: 1_500\n```","title":"Advanced Options - Getting Started","ref":"getting-started.html#advanced-options"},{"type":"extras","doc":"1. **Start Your ExESDB Instance:** Ensure your ExESDB instance is running and reachable.\n2. **Initialize Commanded:** Once configured, Commanded will use the ExESDB adapter for event storage.\n\n3. **Event Handling:** Use your registered event type mapper to handle event types efficiently.","title":"Using the Adapter - Getting Started","ref":"getting-started.html#using-the-adapter"},{"type":"extras","doc":"Enable detailed logging to troubleshoot:\n\n```elixir\nconfig :logger, :console,\n  format: \"$time [$level] $metadata$message\\n\",\n  metadata: [:mfa, :request_id]\n```\n\nCheck logs for information on event handling and adapter performance.","title":"Debugging and Logs - Getting Started","ref":"getting-started.html#debugging-and-logs"},{"type":"extras","doc":"Congratulations! You’ve set up and configured the ExESDB Commanded Adapter in your project. Enjoy a seamless event-driven architecture with the power of Commanded and ExESDB.\n\n---","title":"Summary - Getting Started","ref":"getting-started.html#summary"},{"type":"extras","doc":"","title":"Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html"},{"type":"extras","doc":"---","title":"Event Sourcing with CQRS Guide - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#event-sourcing-with-cqrs-guide"},{"type":"extras","doc":"Event Sourcing and CQRS (Command Query Responsibility Segregation) are architectural patterns that have gained significant traction in recent years for building scalable, maintainable, and resilient applications.","title":"Introduction - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#introduction"},{"type":"extras","doc":"Event Sourcing has its roots in finance, where maintaining a clear, auditable trail of transactions is paramount. Over time, its advantages in state management and consistency have led to its adoption in various software domains. CQRS emerged to better handle the complexities in systems where read and write models have different scaling requirements and logic.","title":"History - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#history"},{"type":"extras","doc":"- **Event Sourcing**: Instead of storing just the current state, all changes (events) are stored. The state is then derived by replaying these events.\n- **CQRS**: Segregates the read and write parts of the application by using separate models to optimize performance, security, and scalability.","title":"Principles - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#principles"},{"type":"extras","doc":"These patterns are particularly suited for systems where:\n\n- Auditability and traceability are required.\n- Complex domains requiring distinct read and write optimizations.\n- Scalable systems where different scaling strategies are needed.","title":"Applicability - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#applicability"},{"type":"extras","doc":"- **Audit Trail**: Easily audit past changes as all events are stored.\n- **Scalability**: Tailor read/write models to specific performance needs.\n- **Resilience**: Replay events in case of failures, ensuring recovery.\n- **Decoupling**: Separate concerns lead to cleaner, more maintainable code.","title":"Motivation - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#motivation"},{"type":"extras","doc":"","title":"Key Concepts and Patterns - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#key-concepts-and-patterns"},{"type":"extras","doc":"- **Event**: A record of a change that occurred in the system.\n- **Event Store**: A database designed to store events in order.\n- **Aggregate**: A cluster of domain objects treated as a single unit, modified by handling events.","title":"Event Sourcing - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#event-sourcing"},{"type":"extras","doc":"- **Command**: Represents an intention to perform an action.\n- **Query**: Request for information, optimized for performance.\n- **Read Model**: Optimized for retrieval operations, often denormalized.\n- **Write Model**: Optimized for handling business logic and making changes.","title":"CQRS - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#cqrs"},{"type":"extras","doc":"- **Simplified Logic**: By separating read and write models, complex logic is easier to manage.\n- **Improved Performance**: Optimize read operations separately from write operations.\n- **Enhanced Collaboration**: Different teams can work on read and write models independently.","title":"Benefits - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#benefits"},{"type":"extras","doc":"Event Sourcing with CQRS provides a robust framework for building applications that are scalable, maintainable, and transparent. Understanding and applying these patterns empowers developers to tackle complex domains with confidence.","title":"Conclusion - Event Sourcing with CQRS","ref":"event-sourcing-with-cqrs.html#conclusion"},{"type":"extras","doc":"# ex-esdb-commanded-adapter\nAn ExESDB Adapter for the fantastic Commanded Library","title":"Read Me","ref":"readme.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}